/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.KualifikasiJurusan;
import com.portofolio.entity.vo.KualifikasiJurusanId;

@Lazy
@Repository
public interface KualifikasiJurusanDao extends CrudRepository<KualifikasiJurusan, KualifikasiJurusanId> {

    @Cacheable("KualifikasiJurusanDaofindOneBy")
    KualifikasiJurusan findOneByIdKodeAndIdKdProfileAndKdDepartemen(String kode, Integer kdProfile, String KdDepartemen);
    

    @Query(QListAll)
    @Cacheable("KualifikasiJurusanDaoFindAllList")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page, @Param("kdDepartemen") String kdDepartemen);
    
    @Query(QListAll + " and model.namaKualifikasiJurusan like %:namaKualifikasiJurusan% ")
    @Cacheable("KualifikasiJurusanDaoFindAllListPage")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaKualifikasiJurusan") String namaKualifikasiJurusan, Pageable page, @Param("kdDepartemen") String kdDepartemen);
    
    @Query(QListAll + " and model.id.kode like :kode")
    @Cacheable("KualifikasiJurusanDaoFindByKode")
    Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") String kode, @Param("kdDepartemen") String kdDepartemen);
    
    
    
    String QListAll ="select new map(model.id.kdKdKualifikasiJurusan as kdKdKualifikasiJurusan,model.id.kdProfile as kdProfile "
            + ", model.namaKualifikasiJurusan as namaKualifikasiJurusan " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kdPendidikan as kdPendidikan "
            + ", pendidikan.namaPendidikan as namaPendidikan " 
            + ", model.kdJenisPegawai as kdJenisPegawai "
            + ", jenisPegawai.namaJenisPegawai as namaJenisPegawai " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.kdDepartemen as kdDepartemen " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", departemen.namaDepartemen as namaDepartemen"
            + ", model.version as version )" 
            + " from KualifikasiJurusan model "
            + "left join model.id id "
            + "left join model.departemen departemen "
            + "left join model.pendidikan pendidikan "
            + "left join model.jenisPegawai jenisPegawai "
            + "where id.kdProfile=:kdProfile "
            + "and departemen.id.kdProfile=id.kdProfile "
            + "and model.kdDepartemen =:kdDepartemen "; 

}
